PETSc version 3.15.5
Fix/Edit manual page

# MatMatMatMult

Performs Matrix-Matrix-Matrix Multiplication D=A*B*C.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode MatMatMatMult(Mat A,Mat B,Mat C,MatReuse scall,PetscReal fill,Mat *D)

Neighbor-wise Collective on Mat

### Input Parameters

| A | - the left matrix
| B | - the middle matrix
| C | - the right matrix
| scall | - either MAT_INITIAL_MATRIX or MAT_REUSE_MATRIX
| fill | - expected fill as ratio of nnz(D)/(nnz(A) + nnz(B)+nnz(C)), use PETSC_DEFAULT if you do not have a good estimate if the result is a dense matrix this is irrelevent

### Output Parameters

| D | - the product matrix

### Notes

Unless scall is MAT_REUSE_MATRIX D will be created.

MAT_REUSE_MATRIX can only be used if the matrices A, B and C have the same nonzero pattern as in the previous call

To determine the correct fill value, run with -info and search for the string "Fill ratio" to see the value actually needed.

If you have many matrices with the same non-zero structure to multiply, you should use MAT_REUSE_MATRIX in all calls but the first or

### See Also

MatMatMult, MatPtAP()

### Level

intermediate

### Location

src/mat/interface/matrix.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages